import 'package:graphic/src/attr/single_linear/color.dart';
import 'package:graphic/src/attr/single_linear/shape.dart';
import 'package:graphic/src/attr/single_linear/size.dart';
import 'package:graphic/src/attr/position.dart';
import 'package:graphic/src/geom/adjust/base.dart';

import 'base.dart';
import 'shape/line.dart';

class LineGeom extends Geom {
  LineGeom({
    ColorAttr color,
    ShapeAttr shape,
    SizeAttr size,
    PositionAttr position,
    Adjust adjust,
  }) {
    this['color'] = color;
    this['shape'] = shape;
    this['size'] = size;
    this['position'] = position;
    this['adjust'] = adjust;
  }

  @override
  GeomType get type => GeomType.line;
}

class LineGeomState<D> extends GeomState<D> {}

class LineGeomComponent<D> extends GeomComponent<LineGeomState<D>, D> {
  @override
  LineGeomState<D> get originalState => LineGeomState<D>();

  @override
  get defaultShape => line;

  @override
  double get defaultSize => 1;
}
